"these Methods are already there in Squeak"
SequenceableCollection class removeSelector: #streamContents:.
Object removeSelector: #asString.
String removeSelector: #asInteger.

"We have to replace these methods by better ones later."
SmallWiki.HtmlWriteStream class	compile: 'defaultHtmlEscapeTable'		classified: 'configuration'.
SmallWiki.HtmlWriteStream class	compile: 'defaultAttributeEscapeTable'	classified: 'configuration'.
SmallWiki.WikiParser class		compile: 'parserDefinitionComment'	classified: 'generated-comments'.
SmallWiki.Server class			compile: 'defaultWorkspace'			classified: 'generated-comments'.

"Fix this bug - wrong Namespace"
Smalltalk.Separator relocateTo: SmallWiki.

"remove some classes from the bundle"
SmallWiki.AbstractExternalLinkChecker removeFromSystem.

"In Squeak we use Comanche, so change the superclass to prevent an error during filein"
Smalltalk.SmallWiki defineClass: #SwazooSite
	superclass: #{Core.Object}
	indexedType: #none
	private: false
	instanceVariableNames: 'server'
	classInstanceVariableNames: ''
	imports: ''
	category: 'SmallWiki Server-Swazoo'.

"Rename each class"
SmallWiki allClasses do: [ :each |
	(RenameObjectRefactoring
		renameObjectNamed:	(each fullyQualifiedReferenceFrom: nil) asString
		to:						('SW', each name asString)
	) execute
].

SmallWiki allClasses do: [ :each |
	oldCat := each category.
	newCat := (oldCat copyReplaceAll: 'SmallWiki' with: '') trimBlanks copyReplaceAll: '-' with: ''.
	(#('Action' 'Security' 'Server' 'Structure' 'Storage' 'Template' 'Document' 'Visitor' 'Parser' 'Tests' 'Admin')
		includes: (newCat copyReplaceAll: '-' with: ''))
			ifTrue:	[ each category: 'SmallWiki-', newCat. ]
			ifFalse:	[ each category: 'SmallWiki-Others'. ]
].

(XProgramming.SUnit.TestCase allSubclasses select: [ :i | i environment = SmallWiki ])
	do: [ :each | each category: 'SmallWiki-Tests' ].

"Rename some other classes"
classes := Dictionary new
	at: Timestamp				put: 'TimeStamp';
	yourself.
classes keysAndValuesDo: [ :k :v |
	(RenameObjectRefactoring
		renameObjectNamed:	(k fullyQualifiedReferenceFrom: nil) asString
		to:						(v)
	) execute
].

"fileout the bundle"
bundle := (BundleModel allInstances select: [ :i | i name = 'SmallWiki' ]) first.
bundle asParcel extensionsDo: [ :class :selector | class organization classify: selector under: '*SmallWiki' ].
bundle fileOut.
fileString := 'SmallWiki.st' asFilename readWriteStream contents.

"Patch these strings"
strings := Dictionary new
	at: 'Net.HttpException'						put: '(Smalltalk at: #''Net.HttpException'')';
	at: 'OS.OsError'								put: '(Smalltalk at: #''OS.OsError'')';
	at: 'Net.HttpClient'							put: '(Smalltalk at: #''Net.HttpClient'')';
	at: 'Swazoo.HTTPServer'						put: '(Smalltalk at: #''Swazoo.HTTPServer'')';
	at: 'Net.HostSpec'							put: '(Smalltalk at: #''Net.HostSpec'')';
	at: 'Net.Settings'								put: '(Smalltalk at: #''Net.Settings'')';
	at: 'Refactory.SmaCC.SmaCCParserError'		put: 'SmaCCParserError';
	at: 'Core.Character'							put: 'Character';
	at: 'Smalltalk.Text'							put: 'Text';
	at: 'BlockClosure'							put: 'BlockContext';
	at: 'GenericException'						put: 'Exception';
	at: (String with: 0 asCharacter)				put: ' ';
	at: 'methodsForUndefined:'					put: 'methodsFor:';
	at: 'SmallWiki.'								put: '';
	at: 'javascript_for_popup'						put: 'javascriptForPopup';
	at: 'postCopy_original'						put: 'postCopyOriginal';
	at: 'renderPolicyCheckbox_oldMethod:'		put: 'renderPolicyCheckboxOldMethod:';
	at: 'executePermission_new'					put: 'executePermissionNew';
	at: 'initialize_unused'							put: 'initializeUnused';
	at: 'positionI'									put: 'PositionI';
	at: 'SWHtmlWriteStream initialize'				put: 'SWHtmlWriteStream initialize';
	at: 'SWAbstractExternalLinkChecker initialize'	put: '"SWAbstractExternalLinkChecker initialize"';
	at: 'category: ''SmallWiki '						put: 'category: ''';
	at: 'TimeStamp now'							put: 'TimeStamp current';
	at: 'displayString'								put: 'asString';
	yourself.

strings keysAndValuesDo: [ :k :v |
	fileString := fileString copyReplaceAll: k with: v.
].

fileStream := 'SmallWiki-VisualWorks-fileout.st' asFilename writeStream
	nextPutAll: fileString;
	close.