'From Squeak3.6 of ''6 October 2003'' [latest update: #5429] on 7 December 2004 at 11:49:07 pm'!
SWServer subclass: #SWKom
	instanceVariableNames: 'comanche '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallWiki-Server'!
Object subclass: #SWSmallWiki
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallWiki-Others'!

!Object methodsFor: 'copying' stamp: 'chbu 12/3/2004 18:22'!
copy
	"Answer another instance just like the receiver. Subclasses typically 
	override this method; they typically do not override shallowCopy."

	^self shallowCopy postCopy! !

!Object methodsFor: '*SmallWiki' stamp: 'chbu 12/3/2004 18:35'!
changed: anAspectSymbol with: aParameter
	"The receiver changed.  The change is denoted by the argument anAspectSymbol.  Usually the argument is a Symbol that is part of the dependent's change protocol, that is, some aspect of the object's behavior, and aParameter is additional information.  Inform all of the dependents."

	self dependents do: [:aDependent | aDependent update: anAspectSymbol with: aParameter]! !

!Object methodsFor: '*SmallWiki' stamp: 'chbu 12/3/2004 18:52'!
update: anAspectSymbol with: aParameter

	^ self update: aParameter! !

!Object methodsFor: '*SmallWiki' stamp: 'chbu 12/3/2004 18:53'!
update: anAspectSymbol with: aParameter from: aSender 

	^ self update: aParameter with: aParameter! !


!Exception methodsFor: '*SmallWiki-Parser' stamp: 'svp 11/6/2003 23:21'!
copyForDebugging
	| instance context1 context2 |

	context1 := self signalerContext.
	context1 := context1 sender.
	context2 := self signalerContext copy.
	instance := self ."copyForReraise."
	instance searchFrom: context2.
	[ context1 notNil ] whileTrue: [
		context2 swapSender: context1 copy.
		context2 := context2 sender.
		context1 := context1 sender ].
	^instance! !


!HttpResponse methodsFor: '*SmallWiki' stamp: 'chbu 12/3/2004 19:31'!
pvtWriteFieldsOn: aStream

	fields isEmptyOrNil ifTrue: [ ^self ].

	fields keysAndValuesDo: [ :k :v |
		v ifNotNil: [
			aStream
				nextPutAll: k;
				nextPutAll: ': ';
				nextPutAll: v;
				nextPutAll: String crlf
		]
	]! !


!SWAccessViewProperty methodsFor: 'public interface' stamp: 'chbu 12/1/2004 20:19'!
computeFor: aWikiItem 
	| currentPropertyPrintString neededPropertyPrintString |
	^SWAuthorisationChecker calculateFor: (self arguments first) on: aWikiItem considering: (aWikiItem allPermissionsCollection select: [:each | 
	currentPropertyPrintString := each name.
	neededPropertyPrintString := (((aWikiItem class name) asString copyAfter: $W), ' View') .
 	currentPropertyPrintString = neededPropertyPrintString			
	] ) first.! !


!SWAction methodsFor: 'callback' stamp: 'chbu 12/1/2004 20:08'!
processFormCallback
	| keys object value mime |
	keys := request fields keys 
		select: [ :key | ('form-callback-' charactersExactlyMatching: key) = 14 ].
	keys := keys collect: [ :key | (key copyFrom: 15 to: key size) asNumber ].
	keys asSortedCollection do: [ :key | 
		object := self request server callback get: key.
		object isNil ifFalse: [
			value := request fieldAt: 'form-callback-' , key asString ifAbsent: [ nil ].
			mime := request fieldAt: 'mime-form-callback-' , key asString ifAbsent: [ String new ].
			self performCallback: object withArguments: (Array with: self with: value with: mime) ] ].
	^keys notEmpty! !


!SWActionOverview methodsFor: 'partialRendering' stamp: 'chbu 12/5/2004 22:39'!
crenderUncheckedPages
	
	| results wikiManager|
	self fixLimitDate: self daysBefore.
	wikiManager := SWWikiManager new.	

	results := wikiManager uncheckedStructuresFrom: (self structure).
	results := (wikiManager executeQuery: (SWQueryProvider new queryEditedAfter: self limitDate) on: results).


	results := wikiManager sort: results withPropertyName: (self sortUsing).

	html break: 2.
	results size = 0 
		ifTrue: 
			[html center: [
			html label: '&nbsp;'.]]
		ifFalse: 
			[html attributeAt: 'cellpadding' put: 4.
			html table: 
					[html tableRow: 
							[html tableHeading: 
									[html 
										anchorWithAction: 
											[:action | 
											action sortUsing: #Title.
											action daysBefore: self daysBefore]
										to: self url
										do: 'Title'].
							html tableHeading: 
									[html 
										anchorWithAction: 
											[:action | 
											action sortUsing: #Type.
											action daysBefore: self daysBefore]
										to: self url
										do: 'Type'].
							html tableHeading: 
									[html 
										anchorWithAction: 
											[:action | 
											action sortUsing: #TimeStamp.
											action daysBefore: self daysBefore]
										to: self url
										do: 'Modified'].
							html tableHeading: 
									[html 
										anchorWithAction: 
											[:action | 
											action sortUsing: #Creator.
											action daysBefore: self daysBefore]
										to: self url
										do: 'Creator']].
					results do: 
							[:child | 
							html tableRow: 
									[html tableData: 
											[(self hasPermission: child class permissionView) 
												ifTrue: [html anchorWithUrl: child url do: child title]
												ifFalse: [html text: child title]].
									html tableData: child class title.
									html tableData: child timestamp asString.
									html tableData: child creatorName.
									html tableData: 
											[html 
												anchorWithAction: [:action | child parent remove: child]
												to: self url
												do: 'remove']
									]
								]
						]]! !


!SWBrokenProperty methodsFor: 'public interface' stamp: 'chbu 12/7/2004 23:27'!
computeFor: aLink 

	^aLink isBroken or: 
			[aLink class = SWLinkExternal 
				ifTrue: [SWKom isThisExternalLinkBroken: aLink]
				ifFalse: [false]]! !


!SWContainsWordProperty methodsFor: 'public interface' stamp: 'chbu 12/1/2004 23:23'!
computeFor: aWikiItem 
	
	| boolean temporaryWord |
	temporaryWord := '*' , self arguments first , '*'.
	boolean := temporaryWord asLowercase match: aWikiItem title asLowercase.
	SWVisitorText block: 
			[:string :parent | 
			(temporaryWord asLowercase match: string asLowercase) ifTrue: [boolean := true]]
		start: aWikiItem document.
	^boolean! !


!SWDocumentTests methodsFor: 'testing-component' stamp: 'chbu 12/2/2004 20:57'!
testCodeSemantic
	self 	
		should: [ self defaultCode code: 'self subclassResponsibility'; evaluateWith: self defaultAction ] 
		raise: "SubclassResponsibility"Error.
	self 
		should: [ self defaultCode code: 'self foo'; evaluateWith: self defaultAction ] 
		raise: MessageNotUnderstood.
	self 
		should: [ self defaultCode code: '1/0'; evaluateWith: self defaultAction ] 
		raise: ZeroDivide.! !


!SWFolderEdit methodsFor: 'rendering' stamp: 'chbu 12/2/2004 20:40'!
renderChildren: aCollection 
	html attributeAt: 'width' put: '100%'.
	html table: [
		html tableRow: [
			html tableHeading: 'Title'.
			html tableHeading: 'Type'.
			html tableHeading: 'Modified'.
			html tableHeading: 'Version'.
			html tableHeading: 'Position'.
			html tableHeading: 'Commands' ].
		aCollection do: [ :child | 
			html tableRow: [
				html tableData: [
					(self hasPermission: child class permissionView) 
						ifTrue: [ html anchorWithUrl: child url do: child title ]
						ifFalse: [ html text: child title ] ].
				html tableData: child class title.
				html tableData: child timestamp asString.
				html tableData: child version asString.
				html tableData: [ self renderChildrenPosition: child ].
				html tableData: [ self renderChildrenCommands: child ] ] ] ]! !


!SWHtmlWriteStream methodsFor: 'private' stamp: 'chbu 12/7/2004 22:20'!
encode: aString with: aDictionary on: aStream
	|  escape |
	aString do: [ :character |
		character := character squeakToIso.
		escape := aDictionary at: character ifAbsent: [ nil ].
		escape isNil
			ifTrue: [ aStream nextPut: character ]
			ifFalse: [ aStream nextPutAll: escape ] ]! !


!SWHtmlWriteStream class methodsFor: 'configuration' stamp: 'chbu 12/1/2004 23:17'!
defaultAttributeEscapeTable
	^self defaultHtmlEscapeTable
		at: 16r0022 asCharacter put: '&quot;';
		at: 16r0026 asCharacter put: '&amp;';
		at: 16r003C asCharacter put: '&lt;';
		at: 16r003E asCharacter put: '&gt;';
		yourself! !

!SWHtmlWriteStream class methodsFor: 'configuration' stamp: 'chbu 12/7/2004 22:20'!
defaultHtmlEscapeTable
	^(Dictionary new)
		at: 16r00A1 asCharacter put: '&iexcl;';
		at: 16r00A2 asCharacter put: '&cent;';
		at: 16r00A3 asCharacter put: '&pound;';
		at: 16r00A4 asCharacter put: '&curren;';
		at: 16r00A5 asCharacter put: '&yen;';
		at: 16r00A6 asCharacter put: '&brvbar;';
		at: 16r00A7 asCharacter put: '&sect;';
		at: 16r00A8 asCharacter put: '&uml;';
		at: 16r00A9 asCharacter put: '&copy;';
		at: 16r00AA asCharacter put: '&ordf;';
		at: 16r00AB asCharacter put: '&laquo;';
		at: 16r00AC asCharacter put: '&not;';
		at: 16r00AD asCharacter put: '&shy;';
		at: 16r00AE asCharacter put: '&reg;';
		at: 16r00AF asCharacter put: '&macr;';
		at: 16r00B0 asCharacter put: '&deg;';
		at: 16r00B1 asCharacter put: '&plusmn;';
		at: 16r00B2 asCharacter put: '&sup2;';
		at: 16r00B3 asCharacter put: '&sup3;';
		at: 16r00B4 asCharacter put: '&acute;';
		at: 16r00B5 asCharacter put: '&micro;';
		at: 16r00B6 asCharacter put: '&para;';
		at: 16r00B7 asCharacter put: '&middot;';
		at: 16r00B8 asCharacter put: '&cedil;';
		at: 16r00B9 asCharacter put: '&sup1;';
		at: 16r00BA asCharacter put: '&ordm;';
		at: 16r00BB asCharacter put: '&raquo;';
		at: 16r00BC asCharacter put: '&frac14;';
		at: 16r00BD asCharacter put: '&frac12;';
		at: 16r00BE asCharacter put: '&frac34;';
		at: 16r00BF asCharacter put: '&iquest;';
		at: 16r00C0 asCharacter put: '&Agrave;';
		at: 16r00C1 asCharacter put: '&Aacute;';
		at: 16r00C2 asCharacter put: '&Acirc;';
		at: 16r00C3 asCharacter put: '&Atilde;';
		at: 16r00C4 asCharacter put: '&Auml;';
		at: 16r00C5 asCharacter put: '&Aring;';
		at: 16r00C6 asCharacter put: '&AElig;';
		at: 16r00C7 asCharacter put: '&Ccedil;';
		at: 16r00C8 asCharacter put: '&Egrave;';
		at: 16r00C9 asCharacter put: '&Eacute;';
		at: 16r00CA asCharacter put: '&Ecirc;';
		at: 16r00CB asCharacter put: '&Euml;';
		at: 16r00CC asCharacter put: '&Igrave;';
		at: 16r00CD asCharacter put: '&Iacute;';
		at: 16r00CE asCharacter put: '&Icirc;';
		at: 16r00CF asCharacter put: '&Iuml;';
		at: 16r00D0 asCharacter put: '&ETH;';
		at: 16r00D1 asCharacter put: '&Ntilde;';
		at: 16r00D2 asCharacter put: '&Ograve;';
		at: 16r00D3 asCharacter put: '&Oacute;';
		at: 16r00D4 asCharacter put: '&Ocirc;';
		at: 16r00D5 asCharacter put: '&Otilde;';
		at: 16r00D6 asCharacter put: '&Ouml;';
		at: 16r00D7 asCharacter put: '&times;';
		at: 16r00D8 asCharacter put: '&Oslash;';
		at: 16r00D9 asCharacter put: '&Ugrave;';
		at: 16r00DA asCharacter put: '&Uacute;';
		at: 16r00DB asCharacter put: '&Ucirc;';
		at: 16r00DC asCharacter put: '&Uuml;';
		at: 16r00DD asCharacter put: '&Yacute;';
		at: 16r00DE asCharacter put: '&THORN;';
		at: 16r00DF asCharacter put: '&szlig;';
		at: 16r00E0 asCharacter put: '&agrave;';
		at: 16r00E1 asCharacter put: '&aacute;';
		at: 16r00E2 asCharacter put: '&acirc;';
		at: 16r00E3 asCharacter put: '&atilde;';
		at: 16r00E4 asCharacter put: '&auml;';
		at: 16r00E5 asCharacter put: '&aring;';
		at: 16r00E6 asCharacter put: '&aelig;';
		at: 16r00E7 asCharacter put: '&ccedil;';
		at: 16r00E8 asCharacter put: '&egrave;';
		at: 16r00E9 asCharacter put: '&eacute;';
		at: 16r00EA asCharacter put: '&ecirc;';
		at: 16r00EB asCharacter put: '&euml;';
		at: 16r00EC asCharacter put: '&igrave;';
		at: 16r00ED asCharacter put: '&iacute;';
		at: 16r00EE asCharacter put: '&icirc;';
		at: 16r00EF asCharacter put: '&iuml;';
		at: 16r00F0 asCharacter put: '&eth;';
		at: 16r00F1 asCharacter put: '&ntilde;';
		at: 16r00F2 asCharacter put: '&ograve;';
		at: 16r00F3 asCharacter put: '&oacute;';
		at: 16r00F4 asCharacter put: '&ocirc;';
		at: 16r00F5 asCharacter put: '&otilde;';
		at: 16r00F6 asCharacter put: '&ouml;';
		at: 16r00F7 asCharacter put: '&divide;';
		at: 16r00F8 asCharacter put: '&oslash;';
		at: 16r00F9 asCharacter put: '&ugrave;';
		at: 16r00FA asCharacter put: '&uacute;';
		at: 16r00FB asCharacter put: '&ucirc;';
		at: 16r00FC asCharacter put: '&uuml;';
		at: 16r00FD asCharacter put: '&yacute;';
		at: 16r00FE asCharacter put: '&thorn;';
		at: 16r00FF asCharacter put: '&yuml;';
		yourself! !

!SWHtmlWriteStream class methodsFor: 'initialization' stamp: 'chbu 12/2/2004 20:47'!
initialize

	PrettyPrint := self defaultPrettyPrint.
	HtmlEscapeTable := self defaultHtmlEscapeTable.
	AttributeEscapeTable := self defaultAttributeEscapeTable.! !


!SWPageEdit methodsFor: 'utilities' stamp: 'chbu 12/3/2004 19:19'!
parserException: anException
	self exception: anException.
	self wiki streamContents: [ :input |
		wiki := String streamContents: [ :output |
"			output nextPutAll: (input next: anException parameter position - 1)."
			output nextPutAll: anException messageText; nextPutAll: ' -> '.
			output nextPutAll: input upToEnd ] ]! !


!SWParserTests methodsFor: 'testing' stamp: 'chbu 12/2/2004 21:00'!
testConfigurationAll
	"The test assures that all definitions of the messages doc\*, html\* and wiki\* are not only 
	defined, but also used."

	| selectors |
	selectors := self class selectors select: [ :each |
		'doc*' match: each ].
	selectors do: [ :each |
		self assert: (self selectors includes: ('SW', (each copyFrom: 4 to: each size)) asSymbol) ].

	selectors := self class selectors select: [ :each |
		'html*' match: each ].
	selectors do: [ :each |
		self assert: (self selectors includes: ('SW', (each copyFrom: 5 to: each size)) asSymbol) ].

	selectors := self class selectors select: [ :each |
		'wiki*' match: each ].
	selectors do: [ :each |
		self assert: (self selectors includes: ('SW', (each copyFrom: 5 to: each size)) asSymbol) ].! !

!SWParserTests methodsFor: 'testing' stamp: 'chbu 12/2/2004 21:02'!
testConfigurationSelectors
	self selectors do: [ :each |
		self assert: (self respondsTo: ('doc' , (each copyAfter: $W)) asSymbol) ].
	self selectors do: [ :each |
		self assert: (self respondsTo: ('html' , (each copyAfter: $W)) asSymbol) ].
	self selectors do: [ :each |
		self assert: (self respondsTo: ('wiki' , (each copyAfter: $W)) asSymbol) ].! !

!SWParserTests methodsFor: 'resources' stamp: 'chbu 12/1/2004 21:04'!
resourcesForDoc
	^self selectors collect: [ :each |
		self perform: ('doc' , (each copyAfter: $W)) asSymbol ]! !

!SWParserTests methodsFor: 'resources' stamp: 'chbu 12/1/2004 21:04'!
resourcesForHtml
	^self selectors collect: [ :each |
		self perform: ('html' , (each copyAfter: $W)) asSymbol ]! !

!SWParserTests methodsFor: 'resources' stamp: 'chbu 12/1/2004 21:04'!
resourcesForWiki
	^self selectors collect: [ :each |
		self perform: ('wiki' , (each copyAfter: $W)) asSymbol ]! !

!SWParserTests methodsFor: 'resources' stamp: 'chbu 12/1/2004 20:50'!
selectors
	^#( SWEmpty SWEscaping #SWHeader #SWHorizontalRule #SWLink #SWList #SWParagraph #SWPreformatted #SWTable #SWText #SWSmilie #SWCode )! !


!SWPropertyDescription class methodsFor: 'naming' stamp: 'chbu 11/21/2004 23:54'!
shortName

	| tshortname tname |
	tname := self name asString.
	tshortname := tname copyFrom: 3 to: tname size - 'Property' size.
	^Symbol intern: tshortname! !


!SWRecentChanges methodsFor: 'accessing' stamp: 'chbu 12/5/2004 22:35'!
changes
	changes isNil ifTrue: [
		changes := OrderedCollection new.
		[ :collection |
			SWVisitorStructure block: [ :each |
				(self hasPermission: each class permissionView)
					ifTrue: [ collection addLast: each ]
			]
			start: structure
		] value: changes.
		changes := changes
			groupBy: [ :item | item timestamp asDate ]
			having: [:a | true]
	].
	^changes! !


!SWRSSChangesFeed methodsFor: 'rendering' stamp: 'chbu 12/5/2004 22:37'!
renderStructures: aCollection at: aDate
	aCollection do: [ :each |
		html tag: 'item' do: [
			html tag: 'title' do: each title.
			html tag: 'link' do: self server basePathButLast , each url.
			html tag: 'pubDate' do: each timestamp asString.
			html tag: 'description' do: each modificationString.
			html tag: 'content:encoded' do: [
				html nextPutAll: '<!![CDATA['.
				html heading: each title.
				self renderHtmlView: each.
				html nextPutAll: ']]>' ] ] ]! !


!SWRequest methodsFor: 'private' stamp: 'chbu 12/1/2004 20:07'!
basicAuthentication: aString
	| readStream |
	readStream := (Base64MimeConverter mimeDecodeToChars: aString readStream) 
		upToEnd asString readStream.
	username := readStream upTo: $:.
	readStream atEnd 
		ifFalse: [ password := readStream upToEnd ]! !


!SWSearch methodsFor: 'accessing-calculated' stamp: 'chbu 12/2/2004 20:41'!
fullExpression
	^String streamContents: [ :stream |
		stream nextPut: $*; nextPutAll: self expression withBlanksTrimmed; nextPut: $* ]! !

!SWSearch methodsFor: 'private' stamp: 'chbu 12/2/2004 20:42'!
performSearch	
	| collection |
	collection := Set new.
	SWVisitorText
		block: [ :string :parent |
			" actually this is a bug, it should check permission of the parent and 
			  not of the current structure "
			(self hasPermission: parent class permissionView) ifTrue: [
				(self fullExpression asLowercase match: string asLowercase)
					ifTrue: [ collection add: parent ] ] ]
		start: self startStructure.
	^collection! !


!SWSecurityInformation methodsFor: 'testing' stamp: 'chbu 12/1/2004 20:06'!
assertPermission: aPermission
	"Assert that aPermission is valid in the receiver, throws a UnauthorizedError if
	the permission is missing."

	(self hasPermission: aPermission)
		ifFalse: [ SWUnauthorizedError signal "With: self" ]! !


!SWServer methodsFor: 'configuration-pages' stamp: 'chbu 12/1/2004 19:45'!
defaultPageCopyright
	^SWPage
		title: 'Copyright'
		parse: SWSmallWiki licenseString! !

!SWServer methodsFor: 'initialize' stamp: 'chbu 12/3/2004 18:45'!
initializeDependent

	Smalltalk addToStartUpList: self class.! !


!SWKom methodsFor: 'accessing' stamp: 'svp 11/7/2003 01:14'!
comanche

	^comanche! !

!SWKom methodsFor: 'accessing' stamp: 'svp 11/7/2003 01:15'!
comanche: anHttpService

	comanche := anHttpService! !

!SWKom methodsFor: 'accessing' stamp: 'svp 11/7/2003 01:28'!
port

	^self comanche isNil
		ifTrue: [port]
		ifFalse: [self comanche portNumber]! !

!SWKom methodsFor: 'accessing' stamp: 'svp 11/7/2003 01:29'!
port: aNumber

	self comanche isNil
		ifTrue: [port := aNumber]
		ifFalse: [self comanche portNumber: aNumber]! !

!SWKom methodsFor: 'initialize' stamp: 'chbu 12/1/2004 23:34'!
initialize

	super initialize.
	ip := self class defaultIp.
	host := self class defaultHost.! !

!SWKom methodsFor: 'serving' stamp: 'svp 11/7/2003 01:30'!
isRunning

	^self comanche isRunning! !

!SWKom methodsFor: 'serving' stamp: 'svp 11/7/2003 01:30'!
isServing

	^self comanche isRunning! !

!SWKom methodsFor: 'serving' stamp: 'svp 11/7/2003 01:20'!
start
	"We are just going to plug the receiver into some Comanche
	module hierarchy, therefore, this message doesn't make sense.

	See the class side for example server configurations"

	self comanche start! !

!SWKom methodsFor: 'serving' stamp: 'svp 11/7/2003 01:20'!
stop
	"We are just going to plug the receiver into some Comanche
	module hierarchy, therefore, this message doesn't make sense.

	See the class side for example server configurations"

	self comanche stop! !

!SWKom methodsFor: 'request handling' stamp: 'svp 11/10/2003 11:13'!
prepareRequest: aHTTPRequest
	^(SWRequest server: self)
		headers: (self prepareRequestHeaders: aHTTPRequest);
		fields: (self prepareRequestFields: aHTTPRequest);
		cookies: (self prepareRequestCookies: aHTTPRequest);
		url: (self prepareRequestUrl: aHTTPRequest);
		updateAuthentication;
		yourself! !

!SWKom methodsFor: 'request handling' stamp: 'chbu 12/7/2004 21:12'!
prepareRequestCookies: aHTTPRequest
	| cookies |
	cookies := Dictionary new.
	aHTTPRequest cookies keysAndValuesDo: [ :key :value |
		cookies at: key put: value ].
	^cookies! !

!SWKom methodsFor: 'request handling' stamp: 'chbu 12/7/2004 21:52'!
prepareRequestFields: aHTTPRequest
	| fields |
	fields := Dictionary new.
	aHTTPRequest getFields keysAndValuesDo: 
		[ :key :value |
		fields at: key put: value isoToSqueak ].
	aHTTPRequest postFields keysAndValuesDo: 
		[ :key :value |
		fields at: key put: value first withSqueakLineEndings isoToSqueak ].
	aHTTPRequest multipartFormFieldsDo:
		[ :chunk |
		fields at: chunk fieldName put:
			(String streamContents: [ :strm | chunk saveToStream: strm]).
		fields at: 'mime-', chunk fieldName put:
			(chunk contentType).
		].
	^fields! !

!SWKom methodsFor: 'request handling' stamp: 'chbu 12/7/2004 21:12'!
prepareRequestHeaders: aHTTPRequest
	| headers |
	headers := Dictionary new.
	aHTTPRequest header keysAndValuesDo: [ :item :value |
		headers at: item name put: value ].
	^headers! !

!SWKom methodsFor: 'request handling' stamp: 'chbu 12/7/2004 21:12'!
prepareRequestUrl: aHTTPRequest
	^aHTTPRequest url! !

!SWKom methodsFor: 'request handling' stamp: 'chbu 12/7/2004 22:14'!
prepareResponse: swResponse
	| komResponse |
	komResponse := HttpResponse new
		contentType:	swResponse type squeakToIso;
		status:			(HttpResponse statusSymbolFor: swResponse status);
		contents:		swResponse stream contents squeakToIso readStream;
		yourself.
	self prepareResponseHeader: komResponse from: swResponse.
	swResponse cookies isEmpty ifFalse: [
		self prepareResponseCookie: komResponse from: swResponse ].
	^komResponse! !

!SWKom methodsFor: 'request handling' stamp: 'chbu 12/7/2004 22:13'!
prepareResponseCookie: response from: aResponse
	| stream  |

	aResponse cookies keysAndValuesDo: [ :key :value |
		stream := WriteStream on: String new.
		stream nextPutAll: key; nextPut: $=.
		value ifNotNil: [stream nextPutAll: value].
		stream nextPutAll: '; path=/'.
		value ifNil: [ stream nextPutAll: '; Max-Age=0; Expires=Sun, 09 Mar 2003 14:43:19 GMT' ].
		response addCookies: (Array with: stream contents squeakToIso) ]! !

!SWKom methodsFor: 'request handling' stamp: 'chbu 12/7/2004 22:14'!
prepareResponseHeader: komResponse from: swResponse

	swResponse headers associationsDo:
		[ :assn |
		komResponse fields at: assn key put: assn value ]

! !

!SWKom methodsFor: 'request handling' stamp: 'chbu 12/7/2004 22:05'!
process: request
	"Accept a Comanche HttpRequest, convert it into a SmallWiki
	request, process it, then convert the SmallWiki response into 
	a Comanche response and answer that."

	| swRequest response |
	swRequest := self prepareRequest: request.

	"Note, don't try and use the SmallWiki exception handling logic (like
	the super implementation does), Comanche can deal with exceptions 
	signaled from here"
	self root process: swRequest.  

	response := self prepareResponse: swRequest response.
"self halt."
	^response.! !


!SWServer class methodsFor: 'help texts' stamp: 'chbu 12/3/2004 18:44'!
defaultWorkspace
	"self defaultWorkspace"

	^(Workspace new contents: 'SmallWiki
Welcome to SmallWiki, a new Wiki-Wiki implementation in Smalltalk. Below you can find some expressions to configure the wiki to your needs.

If you have any questions, please read the official documentation and browse the SmallWiki web-site. There is also a mailing-list where the community is discussing and answering questions. 

	SmallWiki Web-Site
	http://kilana.unibe.ch:9090/SmallWiki

	SmallWiki - Collaborative Content Management
	http://www.iam.unibe.ch/~scg/smallwiki/smallwiki.pdf

Server
Use the following code to create your wiki for the first time. I would suggest to remove that line afterwards, so you don''t accidentally loose your data.

	server := SWKom startOn: 8080.

If you like to change the server parameters use the following messages:

	server host: ''localhost''.
	server ip: ''*''.
	server port: 8080.

And don''t forget to restart the sever afterwards:

	server stop.
	server start.

For certain functionality of SmallWiki, the server needs to know the full domain to be able to build full URLs. Especially when using SmallWiki behind a proxy this setting might be handy:

	server basePath: ''http://localhost:8080''.

Storage
By default there is no automatic storage process running and all the objects are just kept in your image. It is important that you select a proper storage mechanism, when using SmallWiki in a production environment:

	server storage: ImageStorage new.		" fast and secure persistence "
	server storage: nil.					" no persistence "

To set how often your wiki should get stored, use the following command to specify the delay in seconds:

	server storage delay: 60 * 60.

Other storage implementations might provide additional properties. To test your configuration you might want to execute the following code to force a snapshot right now:

	server storage snapshot.

Callback Cache
SmallWiki supports different cache implementation to remember callback-blocks assigned to links and form-elements. Depending on the speed and the memory available on your machine, you might want to change the settings or choose another implementation.

	server callback: SWExpiringCache new.
	server callback check: 100.		" check culling every n-th write-access "
	server callback ttl: 30 * 60.			" seconds to live "

	server callback: SWFifoCache new.
	server callback max: 5000.		" maximal count of objects "
	server callback shrink: 100.		" release rate of objects "

Security
By default there are two default users created during installation: the anonymous and the admin. The anonymous user will be used by default and has got the permissions to add new pages to the wiki and edit existing ones. Evaluate the following expression to inspect and modify this user:

	server userAt: ''anonymous''

In contrast the administrator has to log-in manually and has got all the available permissions, like deleting files, modifying the history, changing the look-and-feel, evaluating Smalltalk expressions on the server, etc. If you use SmallWiki in a production environment, it is very important that you change the default admin-password with the following expression:

	(server userAt: ''admin'')
		password: ''smallwiki''

To create a new role having the permissions to remove and copy a page, evaluate the following expression:

	studentRole := SWBasicRole name: ''student''.
	studentRole add: SWPage permissionRemove.
	studentRole add: SWPage permissionCopy.

To create a new user and assign the anonymous- and the student-role evaluate try the following code:

	anonymousRole := server roles detect: [ :each |
		each name = ''anonymous'' ].
	user := SWUser username: ''stud1'' password: ''power''.
	user add: anonymousRole.
	user add: studentRole.
	server userAdd: user.

Global Options
There are only a few global options to set. One of those options is to tell SmallWiki if it should pretty print the generated html or not. Note that pretty printing is good for development, but for production I suggest to disable it as the engine is faster and the resulting files get smaller:

	SWHtmlWriteStream prettyPrint: true.
	SWHtmlWriteStream prettyPrint: false.') openLabel: 'Welcome to SmallWiki'!
]style[(16 28 26 4113 33)f1b,f1,f1cred;,f1,f1b! !

!SWServer class methodsFor: 'as yet unclassified' stamp: 'chbu 11/22/2004 20:05'!
startUp
	self allInstancesDo: [ :each | each startUp ]! !


!SWKom class methodsFor: 'examples' stamp: 'chbu 12/7/2004 23:27'!
isThisExternalLinkBroken: link
	^'HTTP/* 404 *' match: (HTTPSocket httpGet: link)! !

!SWKom class methodsFor: 'examples' stamp: 'chbu 12/5/2004 22:43'!
startOn: portNumber host: hostName ip: ipAddress
	"This example starts a basic server that serves nothing but
	SmallWiki content.  It also logs the requests to the Transcript.  For
	more advanced configurations, you'll likely want to build
	your own Comanche module assembly."

	| ma inst |
	inst := self new initialize
			ip: ipAddress;
			host: hostName;
			yourself.
	ma := ModuleAssembly core.
	ma logTo: (KomLogger on: Transcript).
	ma addPlug: [ :request | inst process: request ].
	inst comanche: (HttpService on: portNumber named: 'SmallWiki').
"	inst comanche setDebugMode."
	inst comanche plug: ma rootModule; start.
	^inst
! !


!SWSmallWiki class methodsFor: 'as yet unclassified' stamp: 'chbu 10/23/2003 17:19'!
actions

	^actions! !

!SWSmallWiki class methodsFor: 'as yet unclassified' stamp: 'chbu 10/22/2003 08:58'!
authorString

	^'Lukas Renggli, renggli@iam.unibe.ch'! !

!SWSmallWiki class methodsFor: 'as yet unclassified' stamp: 'chbu 12/3/2004 18:43'!
copyrightString

	^'Software Composition Group, University of Berne, 2003'! !

!SWSmallWiki class methodsFor: 'as yet unclassified' stamp: 'chbu 12/1/2004 19:43'!
initialize
	" SWSmallWiki initialize "

	actions := Dictionary new.! !

!SWSmallWiki class methodsFor: 'as yet unclassified' stamp: 'chbu 10/22/2003 09:00'!
licenseString

	^'The MIT License

Copyright (c) 2003 Lukas Renggli
Copyright (c) 2003 Software Composition Group, University of Berne

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.'! !

!SWSmallWiki class methodsFor: 'as yet unclassified' stamp: 'chbu 12/1/2004 20:05'!
versionString

	^'SmallWiki 0.9.53'! !


!SWStorageTests methodsFor: 'testing' stamp: 'chbu 12/1/2004 20:14'!
testSnapshot
	self shouldnt: [ storage threadSnapshot ] raise: "SubclassResponsibility"Error.

	server storage: storage.
	storage stopThread.
	self shouldnt: [ storage threadSnapshot ] raise: "SubclassResponsibility"Error.

	storage changed.
	self should: [ storage threadSnapshot ] raise: "SubclassResponsibility"Error.! !


!SWStructureTests methodsFor: 'testing-serving' stamp: 'chbu 12/5/2004 21:38'!
testProcessSecurity
	| request |
	fd process: (request := self requestWithUrl: '/' action: 'SWPageHistory').
	self deny: ('*Not Found*' match: request response stream contents).
	self assert: ('*Unauthorized*' match: request response stream contents).! !

!SWStructureTests methodsFor: 'testing-versions' stamp: 'chbu 12/5/2004 21:48'!
testVersionTimestamp
	(Delay forSeconds: 0.5) wait.
	fd1 nextVersion.
	self assert: fd1 predecessor timestamp < fd1 timestamp.! !


!SWStylesheetEditor methodsFor: 'repository' stamp: 'chbu 12/3/2004 19:26'!
repositoryFrom: anUrlString 
	^[ (HTTPSocket httpGet: anUrlString) contents ]
		on: Error
		do: [ :err | err return: String new ]! !


!SWTemplateBodyActions methodsFor: 'tools' stamp: 'chbu 12/3/2004 19:14'!
allActions
	^SWAction withAllSubclasses asOrderedCollection
		select: [ :each | each isListable ]! !


!SWTimestampTest methodsFor: 'testing' stamp: 'chbu 11/22/2004 20:21'!
testTagNamed
	
	| page timestampBefore timestampAfter |
	timestampBefore := TimeStamp current.
	page := SWPage title: 'Page 2.1'.
	timestampAfter := TimeStamp current.
	self assert: timestampBefore <= (page property: #Timestamp).
	self assert: timestampAfter >= (page property: #Timestamp)! !


!SWWikiItem methodsFor: 'as yet unclassified' stamp: 'chbu 12/3/2004 18:07'!
copy
	" Answer another instance just like the receiver.
	Subclasses normally override the postCopy
	message, but some objects that should not be
	copied override copy. "

	^self shallowCopy postCopy! !


!SWCode methodsFor: 'evaluation' stamp: 'chbu 12/2/2004 20:55'!
evaluateWith: anAction
	"Evaluates the code of the receiver within aStructure. The message returns the last
	statement of the string. Notifications are ignored."

	^[ self internalEvaluate: self code with: anAction ]
		on: Notification
		do: [ :n | 
			(n isKindOf: RequestAlternateSyntaxSetting) 
				ifTrue: [n resume: false].
			(n isKindOf: InMidstOfFileinNotification)
				ifTrue: [n resume: false].
			n resume ]
! !

!SWCode methodsFor: 'private' stamp: 'chbu 11/16/2003 12:22'!
internalEvaluate: anExpression with: anAction
	"Evaluates anExpression with the given structure and the request."

	^Compiler new
		evaluate: anExpression
		in: nil
		to: anAction
		notifying: self
		ifFail: [ nil ]! !

!SWCode methodsFor: 'private' stamp: 'svp 11/7/2003 00:42'!
selectionInterval

	^1 to: 0! !


!SWPropertyManager methodsFor: 'copying' stamp: 'chbu 12/3/2004 18:15'!
postCopy
	super postCopy.
	properties := properties deepCopy! !


!SWStructure methodsFor: 'serving' stamp: 'chbu 12/1/2004 20:30'!
processSelf: aRequest
	"Look for an action that might be executed on the current structure. If there is no 
	action given, the default one is executed."

	| actionName actionClass |
	actionName := aRequest fieldAt: 'action'.
	actionClass := actionName isNil
		ifFalse: [ Smalltalk 
			at: actionName asSymbol
			ifAbsent: [ self class defaultViewAction ] ]
		ifTrue: [ self class defaultViewAction ].
	self processAction: (actionClass request: aRequest structure: self)! !

!SWStructure methodsFor: 'actions' stamp: 'chbu 12/1/2004 20:29'!
renameTo: aString
	"Rename the title of the receiver. If the receiver is a child of another structure the title is checked to be unique, in case of a problem a \texttt{DuplicatedStructure} exception is thrown. The message returns true if the title has been renamed, else false is returned."

	| container |

	" check if anything needs to be done "
	self title = aString
		ifTrue: [ ^false ].

	" check if has the same id "
	self id = aString asWikiIdentifier ifTrue: [ 
		self title: aString.
		^true ].

	" check if there is a conflict "
	(aString isEmpty or: [ self parent notNil and: [ self parent includes: aString ] ])
		ifTrue: [ ^SWDuplicatedStructure signal: aString ].

	" process links pointing to the receiver (should be enhanced to fix
	  the whole path correctly, currently only leaves are adapted) "
	SWVisitorLinkInternal
		block: [ :link |
			(self == link target and: [ link reference notEmpty ])
				ifTrue: [
					link reference: (String streamContents: [ :stream |
						stream nextPutAll: (link reference copyFrom: 1 to: link reference size - self title size).
						stream nextPutAll: aString ]) ] ]
		start: self root.

	" update structure "
	container := self parent.
	container isNil
		ifFalse: [ container remove: self ].
	self title: aString.
	container isNil
		ifFalse: [ container add: self ].
	^true! !


!SWStructure class methodsFor: 'accessing' stamp: 'chbu 12/3/2004 18:28'!
title
	"Returns the title of this component. Do override this message to specify
	a differnt name."

	^(self name copyAfter: $W) asString! !


!SWWikiParser methodsFor: 'private' stamp: 'chbu 12/1/2004 19:39'!
createLink: aString 
	| name value index link |
	index := aString indexOf: $> ifAbsent: [1].
	value := (aString copyFrom: index + 1 to: aString size - 1) withBlanksTrimmed.
	link := SWLink newTo: value from: self structure.
	index ~= 1 
		ifTrue: 
			[name := aString copyFrom: 2 to: index - 1.
			link text: name withBlanksTrimmed].
	^link! !

!SWWikiParser methodsFor: 'private' stamp: 'chbu 11/12/2003 21:02'!
stringValue: anOrderedCollection 
	^anOrderedCollection first value! !


!SWWikiParser class methodsFor: 'generated-comments' stamp: 'chbu 12/7/2004 23:08'!
parserDefinitionComment

	"Document : 
	DocumentItems {#createDocument};

DocumentItems :
	| DocumentItem
	| DocumentItems <newline> DocumentItem 
	| DocumentItems BlankLine DocumentItem
	| DocumentItems <newline> 
	| DocumentItems BlankLine ;

BlankLine : <blankLine> {#addEmptyParagraph};

DocumentItem :
	HorizontalRule
	| Header
	| List 
	| Preformatted 
	| Table
	| Paragraph ;

###################################################################
HorizontalRule : <horizontalRule> {#addHorizontalRule} ;

Header : <header> 'headerString' Line 'text' {self addHeader: text level: headerString value size} ;

List : <list> 'listType' ParagraphItems 'items' {self addListItem: (SWListItem withAll: items) ofType: listType value};

Preformatted : <preformatted> Line 'text' {self addPreformatted: text};

###################################################################
Table : TableRow 'row' {self addTableRow: row};
TableRow : TableCells 'cells' {SWTableRow withAll: cells};
TableCells : 
	<table> TableParagraphItems 'paragraph' {OrderedCollection with: (SWTableCell withAll: paragraph)}
	| TableCells 'cells' <table> TableParagraphItems 'paragraph' {cells add: (SWTableCell withAll: paragraph); yourself};
TableParagraphItems : 
	{OrderedCollection new}
	| TableParagraphItems 'items' <text> 'text' {self addString: text value to: items}
	| TableParagraphItems 'items' Link 'link' {items add: link; yourself}
	| TableParagraphItems 'items' Smilie 'smilie' {items add: smilie; yourself}
	| TableParagraphItems 'items' Code 'code' {items add: code; yourself}
	| TableParagraphItems 'items' InternalTableParagraphText 'text' {self addString: text to: items} ;
InternalTableParagraphText : 
	<horizontalRule> {#stringValue:}
	| <header> {#stringValue:}
	| <list> {#stringValue:}
	| <nonLinkStart> 'text' {String with: text value last} 
	| <preformatted> {#stringValue:}
	| <any> {#stringValue:};

###################################################################
Paragraph : ParagraphStart 'firstItem' ParagraphItems 'items' 
				{items addFirst: firstItem. 
				self addDocumentItem: (SWParagraph withAll: (self mergeText: items))} ;
ParagraphStart : 
	<text> 'text' {SWText newText: text value} 
	| <nonLinkStart> 'text' {SWText newText: (String with: text value last)} 
	| Smilie {#liftFirstValue:}
	| Code {#liftFirstValue:}
	| Link {#liftFirstValue:}
	| <any> 'char' {SWText newText: char value};
ParagraphItems : 
	{OrderedCollection new}
	| ParagraphItems 'items' <text> 'text' {self addString: text value to: items}
	| ParagraphItems 'items' Link 'link' {items add: link; yourself}
	| ParagraphItems 'items' Smilie 'smilie' {items add: smilie; yourself}
	| ParagraphItems 'items' Code 'code' {items add: code; yourself}
	| ParagraphItems 'items' InternalTableParagraphText 'text' {self addString: text to: items}
	| ParagraphItems 'items' <table> 'text' {self addString: text value to: items};

###################################################################
Link: 
	<link> 'link' {self createLink: link value};

###################################################################
Smilie:
	<smilie> 'smilie' {self createSmilie: smilie value};

###################################################################
# Reads the next line as unformatted string
###################################################################
Line: 
	{''}
	| Line 'line' InternalTableParagraphText 'text' {line, text}
	| Line 'line' <table> 'text' {line , text value}
	| Line 'line' <text> 'text' {line, text value} 
	| Line 'line' <link> 'link' {line, link value}
	| Line 'line' <codeStart> 'bracket' {line, bracket value};

###################################################################
# Code
#	Instead of parsing the code with this parser, we locate the starting ""["" and
#	parse the code using a Smalltalk parser and code.
###################################################################
Code: <codeStart> 'startToken' {self parseCode: startToken};"! !

SWSmallWiki initialize!
SWHtmlWriteStream initialize!

!HttpResponse reorganize!
('accessing-cookies' addCookies: cookies setCookieName:value:expiresDate:expiresTime:path:domain:secure: setCookieName:value:path:)
('comanche processing' asHttpPartialResponseBlock: asHttpResponseTo:)
('accessing' contentLength contentType contentType: contents contents: fieldAt: fieldAt:ifAbsent: fieldAt:ifAbsentPut: fieldAt:put: fields httpVersion isPersistent responseChunkSize status status: statusCode statusCodeAndReason)
('defaults' defaultContentType)
('initialize-release' destroy)
('authentication' hashPassword: secretWord setUsername: setUsername:password:)
('responding' pvtWriteContentLengthOn: pvtWriteContentTypeOn: pvtWriteContentsOn: pvtWriteCookiesOn: pvtWriteStatusOn: writeHeadersOn: writeOn:)
('*SmallWiki' pvtWriteFieldsOn:)
!

